/*
   This program creates an array of BankAccount objects.
   Notice that the array itself must be constructed first,
   and then each object that is to be placed in the array must
   be constructed separately. It is important to remember that
   an "array of objects" is really an array of references to
   objects.
*/

public class ArrayOfObjects
{
  public static void main(String[] args)
  {
    // Create an array (or "data base") of BankAccounts.
    BankAccount[] accounts = new BankAccount[10]; //this is not BankAccount constructor!

    // The array is empty, so the number of accounts is zero.
    int numAccounts = 0;

    // Create several BankAcount objects and put references
    // to them in the array of BankAccount references.
    accounts[numAccounts++] = new BankAccount(10, 1000.00);

    accounts[numAccounts++] = new BankAccount(20, 500.00);

    accounts[numAccounts++] = new BankAccount(30, 1234.00);

    // Print out the accounts (that have been created so far).
    for (int i = 0; i < numAccounts; i++)
       System.out.println( "Balance in account number " + accounts[i].getNumber()
                            + ": " + accounts[i].getBalance() );

    // Deposit $100 in every account.
    for (int i = 0; i < numAccounts; i++)
      accounts[i].deposit(100.00);

    // Print out the accounts again.
    System.out.println(); // print a blank line
    for (int i = 0; i < numAccounts; i++)
       System.out.println( "Balance in account number " + accounts[i].getNumber()
                            + ": " + accounts[i].getBalance() );

    // Print out the actual contents of (all) the array elements.
    // This loop will print out the actual reference values that
    // are held in the array of BancAccount references.
    System.out.println(); // print a blank line
    for (int i = 0; i < accounts.length; i++)
       System.out.println( accounts[i] );
  }
}
