/*
   This program shows that arrays act like objects. So
   for example, declaring an array variable does not
   create an array object. Similarly, an array object
   can have several names (i.e., references).
*/

public class ArraysAreObjects
{
   public static void main( String[] args )
   {
      // Declare an array reference variable.
      int[] myArray;

      // Create an array object and name it myArray.
      myArray = new int[10];

      // Declare two more array reference variables.
      int[] hisArray, herArray;

      // What does the Java system's memory look like after
      // executeting the following two statements?
      hisArray = myArray;
      herArray = new int[10];

      // Print out the contents of the array named herArray.
      // (Notice that we never initialized this array so it
      // holds default values.)
      for (int i = 0; i < herArray.length; i++)
         System.out.println( herArray[i] );

      // Change the contents of the array named hisArray.
      for (int i = 0; i < hisArray.length; i++)
         hisArray[i] = i*i;

      // Print out the contents of the array named myArray.
      // (What is in this array?)
      for (int i = 0; i < myArray.length; i++)
         System.out.println( myArray[i] );
   }
}
