/*
   This program demonstrates the common mistake of indexing
   an array with an array index that is larger than the last
   valid array index.
*/

public class IndexOutOfBounds
{
   public static void main( String[] args )
   {
      // Create an array reference variable, an array object,
      // and point the reference variable at the object.
      int[] randomInts = new int[10];

      // Fill the array with random integers between 1 and 10
      // but "accidentally" go past the end of the array.
      for (int i = 0; i <= randomInts.length; i++)
        randomInts[i] = (int)Math.floor( 10*Math.random() )+1;


     // Here is another line that obviously goes past the end
     // of the array. You might expect the compiler to give you
     // a "compile time" error, but the compiler doesn't pay any
     // attention to the value of the array index. Array index
     // out of bounds errors are always "run time" errors.
     randomInts[10] = 5;
   }
}
