/*
     This shows how two dimensional arrays are implemented as a
     one dimensional array of references to one dimensional arrays.

     This is one way of showing that multi-dimensional arrays
     are really an example of arrays of objects.
*/

public class RaggedArrays
{
   public static void main( String[] args )
   {
      // Here is how we create a rectangular array.
      int[][] rectArray = new int [10][5];  // 10 rows, 5 columns


      // Here is how we create a non rectangular, ragged array.
      // Notice how the new creates an array of references to arrays
      int[][] raggedArray = new int[10][];

      // Now we need to create the "rows" of the ragged array
      for (int i = 0; i < raggedArray.length; i++)
         raggedArray[i] = new int[i+1];  // each call to new creates one row


      // Initialize all of the cells of the array.
      for (int i = 0; i < raggedArray.length; i++)
         for(int j = 0; j < raggedArray[i].length; j++)
            raggedArray[i][j] = i+j;

      // Print out all of the array.
      for (int i = 0; i < raggedArray.length; i++)
      {  for(int j = 0; j < raggedArray[i].length; j++)
            System.out.print( raggedArray[i][j] + " " );
         System.out.println();
      }
      System.out.println();

      // Replace the fourth row of the array with a new array object.
      raggedArray[3] = new int[12];

      // Print out the array again (with the new row).
      for (int i = 0; i < raggedArray.length; i++)
      {  for(int j = 0; j < raggedArray[i].length; j++)
            System.out.print( raggedArray[i][j] + " " );
         System.out.println();
      }
      System.out.println();


      // Create a ragged array using the array initializer syntax.
      int[][] raggedArray2 = { {1}, {2, 3}, {4, 5, 6}, {7, 8}, {9} };

      // Print out all of the array.
      for (int i = 0; i < raggedArray2.length; i++)
      {  for(int j = 0; j < raggedArray2[i].length; j++)
            System.out.print( raggedArray2[i][j] + " " );
         System.out.println();
      }
      System.out.println();
   }
}
