/*
   This program demonstrates searching an array of integers
   for a particular value. The array is searched using both
   a while-loop and an equivalent for-loop.
*/

public class SearchArray
{
   public static void main( String[] args )
   {
      // Create an array reference variable, an array object,
      // and point the reference variable at the object.
      int[] randomInts = new int[100];

      // Fill the array with random integers between 1 and 200.
      for (int i = 0; i < randomInts.length; i++)
        randomInts[i] = (int)Math.floor( 200*Math.random() )+1;

      // Here is the number we will search for.
      int n = 100;

      // 1. Search the array using a while-loop.
      int j = 0;
      while (j < randomInts.length && randomInts[j] != n)
      {
         j++;
      }

      // Print out the result of the search.
      if (j < randomInts.length)
      {
         System.out.println("Found " + n + " at index " + j );
      }
      else
      {
         System.out.println("Did not find " + n + " in the array" );
      }

      // 2. Now search the array using a for-loop.
      int i; // we should not declare this counter inside of the for-loop
      for (i = 0; i < randomInts.length && randomInts[i] != n; i++)
         /* an empty for-loop */;

      // Print out the result of the search.
      if (i < randomInts.length)
         System.out.println("Found " + n + " at index " + i );
      else
         System.out.println("Did not find " + n + " in the array" );

      // 3. Now search the array using a slightly different (but equivalent) for-loop.
      for (i = 0; i < randomInts.length; i++)
         if (randomInts[i] == n)
            break;

      // Print out the result of the search.
      if (i < randomInts.length)
         System.out.println("Found " + n + " at index " + i );
      else
         System.out.println("Did not find " + n + " in the array" );
   }
}
